;W810 R4EA031 PORT VERSION ALPHA
;The replacement of the graphics 
;Version 2 - Startup animation not needed, choices 
;To the choosed directory (def. /usb/other/gfx) save your graphics in XXXX.PNG (def.) / GIF format - depends on choice, 
;where XXXX is the HEX number of the replaced image 
; 
;(c) Hussein 
;(p) Joker XT, geogriffin
;(e) Adow

;Source file by geogriffin...

include "x.inc"

hack_start equ 0x456F5500

;hooks
hook_1 equ 0x44C9E608
hook_2 equ 0x44C9E720
hook_3 equ 0x44C9E690
hook_4 equ 0x44C9E980
hook_5 equ 0x445649F0
hook_5_point equ 0x452ABDD4
hook_6 equ 0x451925D8

;firmware functions
func_malloc equ 0x45453AA8	;definitely correct
func_fileNext equ 0x44E24E88	;probably correct
func_fileSize equ 0x455B4ADC	;definitely correct
func_sub4 equ 0x455ADDD0	;probably correct
func_loadImage equ 0x4542789C	;probably correct

func_light equ 0x455F24C0
func_timer equ 0x4529EAC0

;misc
vector_table_pntr equ 0x4C02C7BC


org hook_1
DCD 0x4C02C7CC

org hook_2
DCD 0x4C02C7CC

org hook_3
DCD 0x4C02C7CC

org hook_4
DCD 0x4C02C7CC

org hook_5
DCD entry_1+1

org hook_6
code16
align 2
ldr r3, _entry_2
bx r3
_entry_2: DCD entry_2+1
entry_2_exit:


org hack_start

entry_2:
code16
align 2
bl entry_2_main

mov r3, 0xEC
lsl r3, r3, 8
cmp r1, r3
ldr r3, _entry_2_exit
bx r3

align 4
_entry_2_exit: DCD entry_2_exit+1


call_func_malloc:
code16
align 2
push {lr}
ldr r3, _iar_file
mov r1, 0
push {r1}
mov r2, 5
mov r1, 1
bl func_malloc

add sp, sp, 4
pop {pc}

align 4
_iar_file: DCD iar_file


local_getNewId:
code16
align 2
push {r4, r5, lr}
sub sp, sp, 0xC
lsl r4, r0, 0
lsl r5, r1, 0
ldr r1, _local_getNewId_FFFF
mov r0, 0
str r0, [sp, 8]
mov r0, sp
strh r1, [r0, 2]
mov r2, 0
lsl r1, r5, 0
lsl r0, r4, 0
ldr r3, _func_fileSize
blx r3

cmp r0, 0
bne local_getNewId_exit

add r2, sp, 4
mov r1, sp
add r0, sp, 8
ldr r3, _func_sub4
blx r3

cmp r0, 0
bne local_getNewId_exit

add r3, sp, 0
add r3, r3, 2
lsl r2, r5, 0
lsl r1, r4, 0
mov r0, sp
ldrh r0, [r0]
ldr r4, _func_loadImage
blx r4

local_getNewId_exit:
mov r0, sp
ldrh r0, [r0, 2]
add sp, sp, 0xC
pop {r4, r5, pc}

align 4
_local_getNewId_FFFF: DCD 0xFFFF
_func_fileSize: DCD func_fileSize+1
_func_sub4: DCD func_sub4+1
_func_loadImage: DCD func_loadImage+1


entry_2_main:
code16
align 2
ldrh r1, [r0]
mov r3, 0xE5
lsl r3, r3, 8
cmp r1, r3
bcc entry_2_main_exit	;exit if oldId < 0xE500

mov r3, 0xEC
lsl r3, r3, 8
cmp r1, r3
bcs entry_2_main_exit	;exit if oldId > 0xEC00

ldr r3, _entry_2_main_vector_table_pntr
ldr r2, _entry_2_main_FFFE3800
ldr r3, [r3]
lsl r1, r1, 1
add r1, r3, r1
ldrh r1, [r1, r2]
strh r1, [r0]	;replaces oldId with the new resid

entry_2_main_exit:
ldrh r1, [r0]
bx lr

align 4
_entry_2_main_vector_table_pntr: DCD vector_table_pntr
_entry_2_main_FFFE3800: DCD 0xFFFE3800


entry_1:
code16
align 2
push {r0, r1, r4-r7, lr}
mov r7, 10
ldr r4, _entry_1_vector_table_pntr
ldr r6, _file_filter
sub sp, sp, 0x3C

mov r0, 7
lsl r0, r0, 9
bl call_func_malloc	;allocate memory for vector table
				; (0x700 highwords) 
str r0, [r4]
mov r5, 0xE5
lsl r5, r5, 8

entry_1_loop_start:
lsl r2, r5, 0
lsl r1, r6, 0
mov r0, sp
bl call_func_fileNext	;get next filename

mov r0, sp
add r1, sp, 0x14
b entry_1_atou_start	;convert filename to unicode

entry_1_atou_next:
strh r2, [r1]
add r0, r0, 1
add r1, r1, 2

entry_1_atou_start:
ldrb r2, [r0]
cmp r2, 0
bne entry_1_atou_next

mov r0, 0
strh r0, [r1]		;finalize unicode string
add r1, sp, 0x14
lsl r0, r6, 0
add r0, 0xC
bl local_getNewId

ldr r2, _entry_1_FFFF
cmp r0, r2
bne entry_1_update_vector_table

lsl r0, r5, 0

entry_1_update_vector_table:
ldr r1, _entry_1_FFFE3800
ldr r3, [r4]
lsl r2, r5, 1	
add r2, r3, r2		;sets up our new vector table with
strh r0, [r2, r1]		; the new resid

add r5, r5, 1		;increment counter

lsl r5, r5, 0x10		;clear 16 most significant bits of r5
lsr r5, r5, 0x10		; to ensure r5 <= 0xFFFF?

mov r1, 0xEC
lsl r1, r1, 8
cmp r5, r1
bcc entry_1_loop_start	;while (r5 < 0xEC00)

ldr r1, [sp, 0x40]
ldr r0, [sp, 0x3C]
bl call_hook_5_point	;call original function

add sp, sp, 0x44
pop {r4-r7, pc}

align 4
_entry_1_vector_table_pntr: DCD vector_table_pntr
_file_filter: DCD file_filter
_entry_1_FFFF: DCD 0xFFFF
_entry_1_FFFE3800: DCD 0xFFFE3800


call_func_fileNext:
code16
align 2
push {r3}
ldr r3, _func_fileNext
mov r12, r3
pop {r3}
bx r12

align 4
_func_fileNext: DCD func_fileNext+1


call_hook_5_point:
code16
align 2
ldr r3, _hook_5_point
bx r3

align 4
_hook_5_point: DCD hook_5_point+1


;final data
align 4
iar_file: db "E:\Mobile\k750\IAR\se\GuiTest\main.c",0
file_filter: db "%04X.png",0
gfx_dir: du "/usb/other/gfx",0